using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Thirdparty.VendorGroup.Cqrs;

public record DeleteVendorGroupByIdRequest(string Id);

public record DeleteVendorGroupByIdCommand(DeleteVendorGroupByIdRequest Data) : IRequest<bool>;

public class DeleteVendorGroupByIdHandler : IRequestHandler<DeleteVendorGroupByIdCommand, bool>
{
    private readonly AppDbContext _context;

    public DeleteVendorGroupByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteVendorGroupByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.VendorGroup
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null) return false;

        _context.VendorGroup.Remove(entity);
        return await _context.SaveChangesAsync(cancellationToken) > 0;
    }
}